Subject: Re: [PATCH] On ppc64le we HAVE_RELIABLE_STACKTRACE

From: Torsten Duwe <[email-masked]>
Date: Tue, 19 Dec 2017 12:28:33 +0100

On Mon, Dec 18, 2017 at 12:56:22PM -0600, Josh Poimboeuf wrote:
> On Mon, Dec 18, 2017 at 03:33:34PM +1000, Nicholas Piggin wrote:
> > On Sun, 17 Dec 2017 20:58:54 -0600
> > Josh Poimboeuf <[email-masked]> wrote:
> > 
> > > On Fri, Dec 15, 2017 at 07:40:09PM +1000, Nicholas Piggin wrote:
> > > > On Tue, 12 Dec 2017 08:05:01 -0600
> > > > Josh Poimboeuf <[email-masked]> wrote:
> > > >   
> > > > > What about leaf functions?  If a leaf function doesn't establish a stack
> > > > > frame, and it has inline asm which contains a blr to another function,
> > > > > this ABI is broken.  
> > > 
> > > Oops, I meant to say "bl" instead of "blr".

You need to save LR, one way or the other. If gcc thinks it's a leaf function and
does not do it, nor does your asm code, you'll return in an endless loop => bug.

> > > > > Also, even for non-leaf functions, is it possible for GCC to insert the
> > > > > inline asm before it sets up the stack frame?  (This is an occasional
> > > > > problem on x86.)  
> > > > 
> > > > Inline asm must not have control transfer out of the statement unless
> > > > it is asm goto.  
> > > 
> > > Can inline asm have calls to other functions?
> > 
> > I don't believe so.
> 
> It's allowed on x86, I don't see why it wouldn't be allowed on powerpc.
> As you mentioned, GCC doesn't pay attention to what's inside asm("").
> 
> > > > > Also, what about hand-coded asm?  
> > > > 
> > > > Should follow the same rules if it uses the stack.  
> > > 
> > > How is that enforced?
> > 
> > It's not, AFAIK. Gcc doesn't understand what's inside asm("").
> 
> Here I was talking about .S files.

asm("") or .S ... the ABI spec is clear, and it's quite easy to follow. You
need a place to save LR before you call another function, and STDU is so
convenient to create a stack frame with a single instruction.
My impression is one would have to be very determined to break the ABI
deliberately.

> > > > > In addition to fixing the above issues, the unwinder also needs to
> > > > > detect interrupts (i.e., preemption) and page faults on the stack of a
> > > > > blocked task.  If a function were preempted before it created a stack
> > > > > frame, or if a leaf function blocked on a page fault, the stack trace
> > > > > will skip the function's caller, so such a trace will need to be
> > > > > reported to livepatch as unreliable.  
> > > > 
> > > > I don't think there is much problem there for powerpc. Stack frame
> > > > creation and function call with return pointer are each atomic.  
> > > 
> > > What if the function is interrupted before it creates the stack frame?

There should be a pt_regs that shows exactly this situation, see below.

> > Then there will be no stack frame, but you still get the caller address
> > because it's saved in LR register as part of the function call. Then
> > you get the caller's caller in its stack frame.
> 
> Ok.  So what about the interrupted function itself?  Looking at the
> powerpc version of save_context_stack(), it doesn't do anything special
> for exception frames like checking regs->nip.
> 
> Though it looks like that should be possible since show_stack() has a
> way to identify exception frames.

IIRC x86 errors out if a task was interrupted in kernel context. PPC
save_stack_trace_tsk_reliable() could do the same.

Would that be sufficient?

	Torsten